﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="default.aspx.cs" %>

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    
    <meta name="msapplication-cortanavcd" content="vcd.xml"/>
    
    
    <title>QualiWare</title>
	
	<!-- jQuery -->
    <script src="js/jquery-1.11.3.min.js"></script>

    <!-- Bootstrap -->
    <link rel="stylesheet" href="css/bootstrap.min.css">
	<link rel="stylesheet" href="css/bootstrap-theme.min.css">
	
	<!-- JSON viewer -->
	<script src="js/jquery.json-view.js"></script>	
    <link rel="stylesheet" href="css/jquery.json-view.css">

	<link rel="stylesheet" href="css/highlight.default.min.css">
	<script src="js/highlight.pack.js"></script>
	
	<link rel="shortcut icon" href="favicon.ico" />
	<link rel="stylesheet" href="css/qdo.css">

  </head>
  <body style="padding:10px 25px">
	<div class="page-header">
		<img class="logo" src="./images/logo.png" />
		<img class="archery" src="./images/archery.png" />
	</div>

	<button type="button" class="btn btn-success btn-md pull-right" data-toggle="modal" data-target="#wsSettings" style="margin-top:-76px; margin-right:10px;">
		<span class="glyphicon glyphicon-cog" aria-hidden="true"></span>
	</button>
	
	<div class="alert alert-warning" style="font-size: 120%; margin-bottom: 30px;">
	<b style="text-decoration:underline;display:block; margin-bottom:5px;">License Requirement</b>
	All employees must have a collaboration license (enterprise-wide) to use the RESTful API.<br/> Contact your QualiWare representative or email us at support@qualiware.com for more information.</span>
	</div>
	
	<div>
		<img class="smiley-start" src="./images/smiley-blink.gif"/>
		<div class="smiley-thumb">
			<div class="alert alert-success" data-type="happy" title="Whoop whoop... :)"><img src="./images/smiley-green.png"/><span>Happy</span></div>
			<div class="alert alert-warning" data-type="impatient" title="Come on... :|"><img src="./images/smiley-yellow.png"/><span>Impatient</span></div>
			<div class="alert alert-danger" data-type="angry" title="I'm not doing this again... :("><img src="./images/smiley-red.png"/><span>Angry</span></div>
		</div>
	</div>
	
	<!-- examples -->
	<div class="content">
		<h2>REST-ful WebService</h2>
		<h3>Complete options list</h3>
		<h5><a href="{wsUrl}/help" target="_blank">{wsUrl}/help</a></h5>
		<span class="label label-warning" style="font-size:12px;">Examples in this page are built using jQuery v1.11-3.</span>
		
		<!-- example1 -->
		<div id="example1" class="example">
			<h3>Login and retrieve Session ID</h3>
			<h5>{wsUrl}/{dataType}/login</h5>
			<div>
			<b>POST method</b><br/>Parameters:<br/>
			<ul>
				<li>Login (User login, domain user or local QEF user)</li>
				<li>Password, (user password)</li>
				<li>AuthorityKind, ("Domain" | "Local" | "Any")</li>
				<li>Authority,  (Domain name if AuthorityKind="Domain" otherwise empty)</li>
			</ul>
			</div>
			<b>Ex1: Get Session ID:</b>
			
<pre class="bg-info"><code class="javascript">$.ajax(<span class="json">{
	type: "POST",
	contentType: "application/json; charset=utf-8",
	dataType: "{dataType}",
	url: "{wsUrl}/login",
	data: JSON.stringify({
		authority: "", 
		authorityKind: "Local", 
		login: "{userid}", 
		password: "{password}"
	})
}</span>)
.done(function(data){
	// data handling
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>	

		</div>
	
		<!-- example1a -->
		<div id="example1a" class="example">
			<h3>Check if a session is valid</h3>
			<h5>{wsUrl}/{dataType}/isloggedin/{sessionId}</h5>
			<b>Ex1a: Validate Session ID:</b>
			
<pre class="bg-info"><code class="javascript">$.ajax(<span class="json">{
	type: "GET",
	contentType: "application/json; charset=utf-8",
	dataType: "{dataType}",
	url: "{wsUrl}/{dataType}/isloggedin/{sessionId}"
}</span>)
.done(function(data){
	// data handling
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>	

		</div>
	
		<!-- example1b -->
		<div id="example1b" class="example">
			<h3>End session</h3>
			<h5>{wsUrl}/{dataType}/logout/{sessionId}</h5>
			<b>Ex1b: Logout Session ID</b>
			
<pre class="bg-info"><code class="javascript">$.ajax(<span class="json">{
	type: "GET",
	contentType: "application/json; charset=utf-8",
	dataType: "{dataType}",
	url: "{wsUrl}/{dataType}/logout/{sessionId}"
}</span>)
.done(function(data){
	// data handling
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>	

		</div>
	
		<!-- example2 -->
		<div id="example2" class="example">
			<h3>Repository</h3>
			<h5>{wsUrl}/{dataType}/QIS/{sessionId}/rep/{repositoryId}/data</h5>
			<b>Ex2: Get repository data</b>
			
<pre class="bg-info"><code class="javascript">$.ajax(<span class="json">{
	type: "GET",
	contentType: "application/json; charset=utf-8",
	dataType: "{dataType}",
	url: "{wsUrl}/{dataType}/QIS/{sessionId}/rep/{repositoryId}/data"
}</span>)
.done(function(data){
	// data handling
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>	

		</div>
	
		<!-- example2a -->
		<div id="example2a" class="example">
			<h3>Configuration</h3>
			<h5>{wsUrl}/{dataType}/QIS/{sessionId}/rep/{repositoryId}/conf/{configurationId}</h5>
			<b>Ex2a: Get configuration data</b>
			
<pre class="bg-info"><code class="javascript">$.ajax(<span class="json">{
	type: "GET",
	contentType: "application/json; charset=utf-8",
	dataType: "{dataType}",
	url: "{wsUrl}/{dataType}/QIS/{sessionId}/rep/{repositoryId}/conf/{configurationId}"
}</span>)
.done(function(data){
	// data handling
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>	

		</div>
		
		<!-- example3 -->
		<div id="example3" class="example">
			<h3>Find objects by template</h3>
			<h5>{wsUrl}/{dataType}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/findobjects</h5>
			<b>POST method</b><br/>Parameters:<br/>
			<ul>
				<li>templates (Array of &lt;string&gt; containing template names)</li>
				<li>filter (Array of &lt;string,string&gt; containing attribute and value)</li>
				<li>filterType (Handling of multiple filters, "And" | "Or")</li>
				<li>detectMetamodelFormat (set to false in order to skip metamodel detection)</li>
				<li>order (Array of &lt;string,string&gt; containing attribute name and sorting order)</li>
				<li>top (Max number of object to collect, 0 for no limit)</li>
				<li>skip (Number of objects to skip before object collection is started)</li>
			</ul>
			<b>Ex3: Find all workflows sorted alphabetically</b>
			
<pre class="bg-info"><code class="javascript">$.ajax(<span class="json">{
	type: "POST",
	contentType: "application/json; charset=utf-8",
	dataType: "{dataType}",	
	url: "{wsUrl}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/findobjects",
	data: JSON.stringify({
		templates : ["BusinessProcessDiagrams"],
		filter: [],
		filterType: "And",
		detectMetamodelFormat: false,
		order: [{
			key: "Name", 
			value: "asc"
		}],
		top: 0,
		skip: 0
	})
}</span>)
.done(function(data){
	// data handling
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>

		</div>
		
		<!-- example3a -->
		<div id="example3a" class="example">
			<b>Ex3a: Find management processes sorted by modification date</b>
<pre class="bg-info"><code class="javascript">$.ajax(<span class="json">{
	type: "POST",
	contentType: "application/json; charset=utf-8",
	dataType: "{dataType}",
	url: "{wsUrl}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/findobjects",
	data: JSON.stringify({
		templates : ["BusinessProcessNetwork", "BusinessProcessDiagram", "WorkFlowDiagram"],
		filter: [{
			key: "Name",
			value: "Manage"
		}],
		filterType: "And",
		detectMetamodelFormat: false,
		order: [{
			key: "AuditMD", 
			value: "desc"
		}],
		top: 25,
		skip: 0
	})
}</span>)
.done(function(data){
	// data handling
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>

		</div>	
		
		<!-- example4 -->
		<div id="example4" class="example">	
			<h3>Read object data</h3>
			<h5>{wsUrl}/{dataType}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/object/{objectId}</h5>
			<b>Ex4: Get all attributes of BusinessProcessNetwork "Chixi Car Rental Processes" in repository</b><br/>
<pre class="bg-info"><code class="javascript">$.ajax({<span class="json">
	type: "GET",
	dataType: "{dataType}",	
	url: "{wsUrl}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/object/{objectId}"
}</span>)
.done(function(data){
	// data handling
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>

		</div>	
		
		<!-- example5 -->
		<div id="example5" class="example">	
			<h3>Get diagram</h3>
			<h5>https://{serverName}/{sitename}/{ConfigurationName}/{RevisionId}-{Language}.svg</h5>
			<b>Ex5: Get diagram of BusinessProcessNetwork "Chixi Car Rental Processes"</b><br/>
			
<pre class="bg-info"><code class="javascript">$.ajax(<span class="json">{
	type: "GET",
	dataType: "{dataType}",
	url: "{wsUrl}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/object/{objectId}"
}</span>)
.done(function(data){
	var objectData = $.parseJSON(data);
	var diagramSrc = "https://{serverName}/{sitename}/Base Configuration/Diagrams/" 
		+ objectData.RevisionId + "-" + objectData.Language + ".svg";
	
	$.ajax(<span class="json">{
		type: "GET",
		dataType: "html",
		url: diagramSrc
	}</span>)
	.done(function(data){
		// data handling
	})
	.fail(function(){
		// diagram is not published
	});
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>

		</div>
		
		<!-- example6 -->
		<div id="example6" class="example">	
			<h3>Run QSQL</h3>
			<h5>{wsUrl}/{dataType}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/RunQsqlExpression</h5>
			<b>Ex6: Run QSQL query</b><br/>
			
<pre class="bg-info">Query:	
<textarea spellcheck="false" class="form-control" style="height: 70px;">SELECT TOP 10 *
FROM BusinessProcessNetwork 
WHERE ApprovalState='Approved'</textarea>
<code class="javascript">$.ajax(<span class="json">{
	type: "POST",
	dataType: "{dataType}",
	url: "{wsUrl}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/RunQsqlExpression",
	data:   window.JSON.stringify({
		query: <span class="query">"{query}"</span>,
		queryOptions: {
			AutoResolve: true,
			Comparison: "DefaultCaseInsensitive",
			IncludeDeleted: false,
			IncludeRemote: false,
			Language: "{languageCode}",
			Scope: 0
		}
	})
}</span>)
.done(function(data){
	// data handling
}
.fail(function(){
	// invalid qsql query
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>

		</div>
		
		<!-- example7 -->	
		<div id="example7" class="example">
			<h3>Run QSQL - TableValued</h3>
			<h5>{wsUrl}/{dataType}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/RunTableValuedQsqlExpression</h5>
			<b>Ex7: Run QSQL query</b><br/>
			
<pre class="bg-info">Query:
<textarea spellcheck="false" class="form-control" style="height: 160px;">
SELECT TOP 25 bp.Name, bp.HasResponsible.Name AS Responsible, bp.ShortDescription
FROM BusinessProcess bp
ORDER BY bp.Name ASC</textarea>
<code class="javascript">$.ajax(<span class="json">{
	type: "POST",
	dataType: "{dataType}",
	url: "{wsUrl}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/RunTableValuedQsqlExpression",
	data: window.JSON.stringify({
		query: <span class="query">"{query}"</span>,
		queryOptions: {
			AutoResolve: true,
			Comparison: "DefaultCaseInsensitive",
			IncludeDeleted: false,
			IncludeRemote: false,
			Language: "{languageCode}",
			Scope: 0
		}
	})
}</span>)
.done(function(data){
	// data handling
}
.fail(function(){
	// invalid qsql query
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>

		</div>
		<hr />
		<!-- example8 -->	
		<div id="example8" class="example">
			<h3>Find all policies</h3>
			<b>Ex8: Run policy query</b><br/>
			
<pre class="bg-info">Retriev all policies:
<textarea spellcheck="false" class="form-control" style="height: 160px;">
SELECT
	T01.Name AS Policy,
	T01.HasResponsible.Name AS "Responsible",
	T01.OwnedBy.Name AS "Owner",
	T02.Name AS Process,
	T03.Name AS "Work Flow"
	FROM Policy AS T01 
LEFT JOIN  BusinessProcess AS T02 ON T01.sys_ObjectId = T02.StrategicAlignment
GRAPHICAL ContainedIn LEFT JOIN  BusinessProcessNetwork AS T03 ON T02.AllAttributes = T03.sys_ObjectId
ORDER BY T01.Name ASC</textarea>
<code class="javascript">$.ajax(<span class="json">{
	type: "POST",
	dataType: "{dataType}",
	url: "{wsUrl}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/RunTableValuedQsqlExpression",
	data: window.JSON.stringify({
		query: <span class="query">"{query}"</span>,
		queryOptions: {
			AutoResolve: true,
			Comparison: "DefaultCaseInsensitive",
			IncludeDeleted: false,
			IncludeRemote: false,
			Language: "{languageCode}",
			Scope: 0
		}
	})
}</span>)
.done(function(data){
	// data handling
}
.fail(function(){
	// invalid qsql query
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>

		</div>
		<hr />		
		<!-- example9 -->	
		<div id="example9" class="example">
			<h3>Execute Generic Query</h3>
			<b>Ex9: Execute predefined query</b><br/>
			
<pre class="bg-info">
Select query:
<select id="predefinedquery" class="form-control" style="max-width: 550px; margin:top: 10px;">
	<option>Loading...</option>
</select>
<code class="javascript">$.ajax(<span class="json">{
	type: "POST",
	dataType: "{dataType}",
	url: "{wsUrl}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/CSharpMethod/GWE_ServiceHandlers.GetGenericQueryFull",
	data: window.JSON.stringify({
		objectAttributes: [
			{
				Name: "GenericQuery", 	// QualiWare template for queries
				Format: "PlainText", 	// default text format in request
				Value: "<span id='queryid'>{query}</span>" 	// query id
			}
		]
	})
}</span>)
.done(function(data){
	// data handling
}
.fail(function(){
	// invalid qsql query
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>

		</div>
		<hr />
		
		<!-- example10 -->	
		<div id="example10" class="example">
			<h3>Update Data</h3>
			<b>Ex10: Update Policy Responsible</b><br/>
			
<pre class="bg-info">
Select policy:
<select id="predefinedquery1" class="form-control" style="max-width: 550px; margin:top: 10px;">
	<option>Loading...</option>
</select>
Select Responsible:
<select id="predefinedquery2" class="form-control" disabled=true style="max-width: 550px; margin:top: 10px;">
	<option>Select policy</option>
</select>
<code class="javascript">$.ajax(<span class="json">{
	type: "POST",
	dataType: "{dataType}",
	url: "{wsUrl}/qis/{sessionId}/rep/{repositoryId}/conf/{configurationId}/object/<span id='policyid'>{policy}</span>/Update",
	data: window.JSON.stringify({
		objectAttributes: [
			{
				Name: "HasResponsible", // metamodel attribute to be updated
				Format: "SingleLink", 	// metamodel format
				Value: "<span id='personid'>{responsible}</span>"  // responsible persons
			}
		]
	})
}</span>)
.done(function(data){
	// data handling
}
.fail(function(){
	// invalid qsql query
});</code><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div></pre>

		</div>
		<hr />
		
		
		
		<!-- custom calls -->	
		<div id="examplex" class="example js-console">
			<h3>Javascript console</h3>
			
<pre class="bg-info" style="min-height: 500px;"><b>Javascript / Jquery</b><code class="javascript">
// Insert some code here...
</code>
<button type="button" class="btn btn-success edit" autocomplete="off">Edit</button><button type="button" class="btn btn-primary run" autocomplete="off">Run</button>
<div class="result"></div>
</pre>

		</div>
		
	</div>
	<!-- end examples -->
	
	<div id="wsSettings" class="modal fade" role="dialog" data-backdrop="static">
	  <div class="modal-dialog">
		<div class="modal-content">
		  <div class="modal-header">
			<span class="connection-status">STATUS: <span></span></span>
			 <h3 class="modal-title">WebService Settings</h3>
		  </div>
		  <div class="modal-body">
			<form class="form-horizontal" role="form">
				<div class="form-group">
					<label class="control-label col-sm-3" for="ServerName">Server Name:</label>
					<div class="col-sm-8">
					  <input type="text" class="form-control" id="ServerName" placeholder="Enter Server Name">
					</div>
				</div>
				<div class="form-group">
					<label class="control-label col-sm-3" for="QEFInstance">QEF Instance Name:</label>
					<div class="col-sm-8">
					  <input type="text" class="form-control" id="QEFInstance" placeholder="Enter QEF Instance Name">
					</div>
				</div>
				<hr/>
				<div class="form-group">
					<label class="control-label col-sm-3" for="Repository">Login:</label>
					<div class="col-sm-3">
						<input type="text" class="form-control" id="Login" placeholder="Enter Login">
					</div>
					<label class="control-label col-sm-2" for="Repository">Password:</label>
					<div class="col-sm-3">
						<input type="password" class="form-control" id="Password" placeholder="Enter Password">
					</div>
				</div>
				<hr/>
				<div class="form-group">
					<label class="control-label col-sm-3" for="Repository">Repository:</label>
					<div class="col-sm-8">
					  <select type="text" class="form-control" id="Repository" placeholder="Select Repository" readonly>
					  </select>
					</div>
				</div>
				<div class="form-group">
					<label class="control-label col-sm-3" for="Configuration">Configuration:</label>
					<div class="col-sm-8">
					  <select type="text" class="form-control" id="Configuration" placeholder="Select Configuration" readonly>
					  </select>
					</div>
				</div>
				<div class="form-group">
					<label class="control-label col-sm-3" for="LanguageCode">Language:</label>
					<div class="col-sm-8">
						<select type="text" class="form-control" id="LanguageCode" placeholder="Select Language" readonly>
						</select>
					</div>
				</div>
				<hr/>
				<div class="form-group">
					<label class="control-label col-sm-3" for="Website">Website Name:</label>
					<div class="col-sm-8">
						<input type="text" class="form-control" id="Website" placeholder="Enter Website Name" readonly />
					</div>
				</div>
				<div class="form-group">
					<label class="control-label col-sm-3">Data type:</label>
					<div class="col-sm-8" style="position:relative;top:7px;">
						<div class="c-inputs-stacked">
						  <label class="c-input c-radio" style="margin-right:10px;">
							<input id="JSON" name="radio-stacked" checked type="radio">
							<span class="c-indicator"></span>
							JSON
						  </label>
						  <label class="c-input c-radio">
							<input id="XML" name="radio-stacked" type="radio">
							<span class="c-indicator"></span>
							XML
						  </label>
						</div>
					</div>
				</div>
				<div class="form-group">
					<label class="control-label col-sm-3" for="Template">Sample Diagram:</label>
					<div class="col-sm-8">
					  <select type="text" class="form-control" id="Template" readonly>
						<option value="" hidden>-- Select Template --</option>
						<option value="BusinessProcessNetwork">BusinessProcessNetwork</option>
						<option value="WorkFlowDiagram">WorkFlowDiagram</option>
						<option value="BusinessProcessDiagram">BusinessProcessDiagram</option>
					  </select>
					</div>
				</div>
				<div class="form-group">
					<label class="control-label col-sm-3" for="ObjectId"></label>
					<div class="col-sm-8">
						<select type="text" class="form-control" id="ObjectId" readonly>
						</select>
					</div>
				</div>
			</form>
		  </div>
		  <div class="modal-footer">
			<button type="button" class="btn btn-success" data-dismiss="modal" id="settingsSave">Save</button>
			<button type="button" class="btn btn-danger" data-dismiss="modal" id="settingsCancel">Cancel</button>
		  </div>
		</div>
	  </div>
	</div>	
    <!-- Include all compiled plugins (below), or include individual files as needed -->
    <script src="js/bootstrap.min.js"></script>
	
	<!-- Examples -->
	<script src="js/examples.js"></script>
  </body>
</html>